Linter:
  stage: CodeQuality
  image: pallam/golangci-lint-cgo:alpine
  needs: []
  variables:
    GOLANGCI_LINT_CACHE: $CI_PROJECT_DIR/cache/
  tags:
    - go-linter
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_TITLE =~ /^hot-fix.*/'
      when: never
    - when: always
  script:
    - apk add make curl file which && make configure_linter
    - golangci-lint version
    - file $(which golangci-lint)
    - file ./pkg/dirtyusage.so
    - mkdir -p $GOLANGCI_LINT_CACHE
    - golangci-lint run -j 2 --timeout 10m0s --max-issues-per-linter 0 --max-same-issues 0 --tests=false --issues-exit-code 0 --out-format checkstyle:lint.report,code-climate:codeclimate.json,colored-line-number
  artifacts:
    reports:
      codequality: codeclimate.json
    paths:
      - codeclimate.json
      - lint.report
  cache:
    key: "linter.cache"
    paths:
      - cache
    when: 'always'
